<?php
	require_once("./system/init/FW.inc");
	if(VIEWE == "limit"){
		$_SESSION['file_manager']['back_page'] = $_SERVER["PHP_SELF"];	//ログイン後に戻るページ
		require_once("./system/init/login_check.inc");
	}
	if(UTILITY != "nonuse"){											//管理画面を使わない場合はリンクをテンプレート側で非表示
		$val['utility'] = UTILITY;
	}
	$val['user_name'] =	$_SESSION['file_manager']['login_id'];			//セッションが有ればログイン情報を表示

	$path = $_SERVER["PHP_SELF"];
	$_SESSION['file_manager']['target_dir'] = '';						//最初に対象ディレクトリをセッションをクリア

//■■■■■■■■■■■■■■■■■■■■■■
//画面表示
//■■■■■■■■■■■■■■■■■■■■■■
	//パラメータ エラーチェック
	$img_prm = $_GET["i"];

	//致命的なエラー
	if(ereg('\.\.', $img_prm)){
		print '不正なパスが入力されました';
		exit;
	}

	$img_prm = ereg_replace('\./', '', $img_prm);
	if($img_prm == '.'){
		$img_prm = '';
	}
	$full_path = TOP_LEVEL.'/'.$img_prm;									// 画像フルパス
//	$dir_ary = split('/', $img_prm);

	//名前で並び替えて前後のファイル名を取得
	$target_file = make_file_list($full_path);
	$val['message'] = array();
	if(empty($target_file['target'])){
		array_push($val['message'], array(text=>'表示可能なファイルがありません。'));
	}

	//ディレクトリ指定を元にディレクトリ一覧を生成
	//現在のディレクトリ
//	$dir_ary_path = $img_prm;
	if($img_prm != ''){
		$dir_ary = split('/', $img_prm);
		$val['dir_path'] =	$dir_ary[count($dir_ary)-1];				//テンプレート変数
	}else{
		$dir_ary = array();
		$val['dir_path'] = TOP_LEVEL_TEXT;								//テンプレート変数
	}
//スライドショー用のパラメータ
//	$val['slide_show_dir'] =  $_GET["chdir"];
//	
	$val['top_level_dir']      = $path.'?i=';
	$val['top_level_dir_text'] = TOP_LEVEL_TEXT;

	//表示指定がファイルなので配列の最後は削除
	if($target_file['is_dir'] == false){
		array_pop($dir_ary);
	}
	$val['dir_ary'] =	array();
	$dir_indent = '';
	$parent_path = '';
	for($i=0; $i<count($dir_ary); $i++){
		$val['dir_ary'][$i]['link_indent'] = $dir_indent.' ├ ';
		$val['dir_ary'][$i]['link']  = $path.'?i='.$parent_path.$dir_ary[$i];
		if($i < count($dir_ary)-1){
			$val['dir_ary'][$i]['link_text'] = $dir_ary[$i];
		}else{
			$val['dir_ary'][$i]['link_text'] = $dir_ary[$i].' *';
		}
		$dir_indent .= ' │';
		$parent_path.= $dir_ary[$i].'/';
	}
	//現在のディレクトリに含まれるサブディレクトリ一覧
	while (list ($key, $array) = each ($target_file['dir_ary'])) {
		array_push($val['dir_ary'], array(link_indent=>$dir_indent.' ├ ', link=>$path.'?i='.$parent_path.$array, link_text=>$array));
	}


	//GETの画像ファイル情報からディレクトリ部分だけ取り出してリンクを作成
	if($target_file['is_dir'] == true){
		if(count($dir_ary) == 0){
			$val['dir_path'] = TOP_LEVEL_TEXT;									//操作対象のディレクトリ
			$val['file_manager'] = 'file_manager.php?chdir=';					//戻るリンク
		}else{
			$val['dir_path'] = $dir_ary[count($dir_ary)-1];						//操作対象のディレクトリ
			$dir_prm = join('/',$dir_ary);
			$val['file_manager'] = 'file_manager.php?chdir='.$dir_prm;			//戻るリンク
		}
	}else{
		$val['dir_path'] = $dir_ary[count($dir_ary)-1];						//操作対象のディレクトリ
		$dir_prm = join('/',$dir_ary);
		$val['file_manager'] = 'file_manager.php?chdir='.$dir_prm;			//戻るリンク
	}

	if(!empty($target_file['next'])){
		$val['link'] = $_SERVER["PHP_SELF"].'?i='.$dir_prm.'/'.$target_file['next'];
		$val['next'] = $_SERVER["PHP_SELF"].'?i='.$dir_prm.'/'.$target_file['next'];
	}
	if(!empty($target_file['target'])){
		$val['link_text'] = $target_file['dir_path'].$target_file['target'];
		$val['link_title'] = $target_file['target'];
		if($target_file['target_width'] > SLIDE_SHOW_MAX_WIDTH){	//スライドショーの最大表示サイズを超えている
			$val['link_width'] = SLIDE_SHOW_MAX_WIDTH;
		}else{
			$val['link_width'] = $target_file['target_width'];
		}
	}
	if(!empty($target_file['previos'])){
		$val['previos'] = $_SERVER["PHP_SELF"].'?i='.$dir_prm.'/'.$target_file['previos'];
	}
	if(empty($dir_prm)){
		$_SESSION['file_manager']['target_dir'] = TOP_LEVEL.'/';				//対象ディレクトリをセッションに保存
	}else{
		$_SESSION['file_manager']['target_dir'] = TOP_LEVEL.'/'.$dir_prm.'/';				//対象ディレクトリをセッションに保存
	}
	htmltemplate::t_include("slide_show.html",$val);

//■■■■■■■■■■■■■■■■■■■■■■
//ファイル一覧生成
//■■■■■■■■■■■■■■■■■■■■■■
function make_file_list($current_img){
	global $icon_ary;
	$result = array();
	if(is_dir($current_img)){			//引数がディレクトリかどうかを調べる
		//パラメータのディレクトリをそのまま使用
//		$file_info = pathinfo($current_img);
		$dir_path = $current_img;
		$result['is_dir'] = true;
	}else{
		//パラメータがファイルならファイルのディレクトリを取得
		$file_info = pathinfo($current_img);
		$dir_path = $file_info['dirname'];
		$result['is_dir'] = false;
	}


	$file_ary = array();
	if(is_readable($dir_path)) {	//ファイルが読み込み可能かどうか
		$ch_dir = dir($dir_path);	//ディレクトリクラス
		//ディレクトリ内のファイルを配列に保存
		$file_ary = array();
		$width_ary = array();
		$dir_ary   = array();
		$file_count = 0;
		while (false !== ($fn = $ch_dir -> read())) {
			if($fn != '.' && $fn != '..'){
				$file_info	 = pathinfo($fn);
				if(is_dir($dir_path.'/'.$fn)){
					//ディレクトリの場合
					array_push($dir_ary, $fn);
				}else{
					//ファイルの場合
					$file_name = $file_info['basename'];
					//拡張子を調べる
					$icon_file = $icon_ary[strtolower($file_info['extension'])];
					
					$image_info = @getimagesize($dir_path.'/'.$fn);		//画像情報取得
					if($icon_file == ENTITY && $image_info) {				//表示可能な画像かどうか？
						$file_count = array_push($file_ary, $file_name);
						array_push($width_ary, $image_info[0]);
					}
				}
			}
		}
		//ディレクトリ内のファイル名の配列をソート
		natsort($file_ary);
		$sorted_ary = array();
		//並び替えた配列を再保存
		while (list ($key, $array) = each ($file_ary)) {
//			echo $key."=".$array.' '.$width_ary[$key]."<br>";
			array_push($sorted_ary, array(name=>$array, width=>$width_ary[$key]));
		}

		//ディレクトリ内の画像一覧をパラメータ配列に格納
		if($dir_path == $current_img){
			//対象がディレクトリなので最初のファイルを表示
			$result['target']       = $sorted_ary[0]['name'];
			$result['target_width'] = $sorted_ary[0]['width'];
			$result['previos']      = ''; 
			$result['next']         = $sorted_ary[1]['name'];
			$result['dir_path']     = $dir_path.'/';
		}else{
			//対象のファイルを探す
			for($num=0; $num<$file_count; $num++){
				if($current_img == $dir_path.'/'.$sorted_ary[$num]['name']){
					$result['target']       = $sorted_ary[$num]['name'];
					$result['target_width'] = $sorted_ary[$num]['width'];
					$result['previos']      = $sorted_ary[$num-1]['name'];
					$result['next']         = $sorted_ary[$num+1]['name'];
					$result['dir_path']     = $dir_path.'/';
					break;
				}
			}
		}
		$ch_dir -> close();

		//ディレクトリ内のディレクトリ一覧をパラメータ配列に格納
		natsort($dir_ary);
		$result['dir_ary'] = $dir_ary;
		
	}
	return $result;
}



?>